package de.tudarmstadt.informatik.hostage.io;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.OutputStream;
import java.io.OutputStreamWriter;
import java.util.List;

import de.tudarmstadt.informatik.hostage.wrapper.Packet;

/**
 * Handles the reading and writing of the socket in- and outputstream for strings
 * @author Mihai Plasoianu
 * @author Wulf Pfeiffer
 */
public class StringReaderWriter implements ReaderWriter {

	private BufferedReader in;
	private BufferedWriter out;

	/**
	 * Constructor
	 * @param in inputstream
	 * @param out outputstream
	 */
	public StringReaderWriter(InputStream in, OutputStream out) {
		this.in = new BufferedReader(new InputStreamReader(in));
		this.out = new BufferedWriter(new OutputStreamWriter(out));

	}

	
	public Packet read() throws IOException {
		return new Packet(in.readLine());
	}

	
	public void write(List<Packet> outputLine) throws IOException {
		for (Packet o : outputLine) {
			out.write(o + "\n");
			out.flush();
		}
	}

}
